### Function Macro

# GObject DEFINE_FINAL_TYPE

since: 2.70

#### Declaration

    #define G_DEFINE_FINAL_TYPE (
      TN,
      t_n,
      T_P
    )

#### Description

A convenience macro for type implementations.

Similar to G_DEFINE_TYPE(), but defines a final type.

See G_DEFINE_TYPE_EXTENDED() for an example.

Available since: 2.70

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type, in lower case, with words separated by `_` (snake case)

`T_P`

  Type: `-`

  The `GType` of the parent type.